﻿using System;
using RimWorld;
using Verse;
namespace FaintingGoats
{
    class ThingComp_SpawnWithHediff : ThingComp
    {
        public override void PostSpawnSetup(bool reloading)
        {
            if (!reloading)
            {
                if (this.parent is Pawn goat)
                {

                    if (Props.hediff != null && this.parent != null)
                    {
                        goat.health.AddHediff(Props.hediff);
                    }
                    else
                    {
                        MoteMaker.ThrowText(goat.PositionHeld.ToVector3(), goat.MapHeld, "Failed to make this pawn have hediff \""+Props.hediff.label+"\"... Is the hediff defined properly?");
                        Log.Error("Failed to make pawn with defName \""+this.parent.def.defName+"\" have hediff \""+Props.hediff.defName+"\"... Is the hediff defined properly?");
                    }
                }
                else
                {
                    Log.Error("Uhm... you just tried to apply \"FaintingGoats.ThingComp_SpawnWithHediff\" to def \"" + this.parent.def.defName + "\"... that's not a pawn.");
                }
            }
        }

        public CompProperties_SpawnWithHediff Props => (CompProperties_SpawnWithHediff)this.props;
    }

    class CompProperties_SpawnWithHediff : CompProperties
    {
        public HediffDef hediff;
        public CompProperties_SpawnWithHediff()
        {
            this.compClass = typeof(ThingComp_SpawnWithHediff);
        }

        public CompProperties_SpawnWithHediff(Type compClass) : base(compClass)
        {
            this.compClass = compClass;
        }
    }
}
